#!/bin/sh -efu

_start_time="$(echo | tai64n)"
_check_time=1

# Checks if the given timestamp isn't before the start time
# of the program. The actual comparison is made until the
# first positive result and then cached.
#
# args: tai64n-timestamp
# returns: 0 --- greater or equal to the start time, 1 --- before it.
check_timestamp()
{
    [ $_check_time -ne 0 ] || return 0

    local ts="$1"
    local _ts=

    case "${BASH_VERSION:-0.0}" in
        [012].*)
            _ts="$(echo -e -n "$ts\n$_start_time" | sort -r | head -1)"
            if [ "$_ts" != "$ts" ]; then
                return 1
            else
                _check_time=0
                return 0
            fi
            ;;
        *)
            if [ "$ts" '>' "$_start_time" -o "$ts" = "$_start_time" ]; then
                _check_time=0
                return 0
            else
                return 1
            fi
            ;;
    esac
}
